﻿using System.Collections;
using UnityEngine;

namespace paint
{
    public class k : MonoBehaviour
    {
        private GameObject gameobjectBall;

        public Vector2 ChainConnector = new Vector2(0f, 0f);
        public Vector2 ballConnector = new Vector2(0f, 0f);

        Sprite Ball;
        private void Awake()
        {
            var mace = ModAPI.CreatePhysicalObject("Pistol", ModAPI.LoadSprite("g.png"));
            mace.gameObject.GetComponent<PhysicalBehaviour>().InitialMass = 0.0005f;
            mace.gameObject.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0005f;
                             mace.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = mace.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerArmFront";
                        prop.armorTier = 4;
                        prop.sprite = "g.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();



            mace.transform.SetParent(gameObject.transform);
            mace.transform.localPosition = new Vector3(ChainConnector.x, ChainConnector.y + 1f);
                        mace.gameObject.FixColliders();

            DistanceJoint2D joint = gameObject.AddComponent<DistanceJoint2D>();
            joint.maxDistanceOnly = true;
            joint.enableCollision = false;
            joint.distance = 4f;
            joint.autoConfigureDistance = false;
            joint.breakForce = Mathf.Infinity;
            joint.breakTorque = Mathf.Infinity;
            joint.anchor = ChainConnector;
            joint.connectedBody = mace.GetComponent<Rigidbody2D>();
            joint.connectedAnchor = ballConnector;
            JointCreated(joint);
        }

        void JointCreated(DistanceJoint2D joint)
        {
            UseWireBehaviour useWireBehaviour = joint.gameObject.AddComponent<UseWireBehaviour>();
            useWireBehaviour.WireColor = Color.grey;
            useWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Wire");
            useWireBehaviour.WireWidth = 0.010f;
            useWireBehaviour.typedJoint = joint;
        }
    }
}