using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace paint
{
    public class paint
    {
        public static void Main()
        {
            		CategoryBuilder.Create("Zuccians Laboratory", "find madman created items here!", ModAPI.LoadSprite("icon.png"));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cyclops Adapter",
                    DescriptionOverride = "Allows the user to fire a laser out of this",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("cyt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ph.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "ph.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                             Instance.AddComponent<EMP12>();
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Gaster Blaster",
                    DescriptionOverride = "Creates a big white beam on activation, good for killing children over and over again",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("gbt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("gb.png");

                             Instance.AddComponent<gb>();
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Spike Hat",
                    DescriptionOverride = "A hat with a spike on top, self explained",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("spt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sa.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "sa.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop2 = ModAPI.FindPhysicalProperties("Weapon");
        prop2.Sharp = true;
        prop2.SharpAxes = new[]
            {
                                                                                                                new SharpAxis(Vector2.up, 0f, 0.1f, true, false),
                };
        phys.Properties = prop2;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Electric Webshooters (Back)",
                    DescriptionOverride = "Webshooters but with a charge, great at tasing",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("web.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ws.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerArm";
                        prop.armorTier = 4;
                        prop.sprite = "ws.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
        Instance.GetComponent<PhysicalBehaviour>().Charge = 200f;
    };
                             Instance.AddComponent<spider>();
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Electric Webshooters (Front)",
                    DescriptionOverride = "Webshooters but with a charge, great at tasing",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("web.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ws.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerArmFront";
                        prop.armorTier = 4;
                        prop.sprite = "ws.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
        Instance.GetComponent<PhysicalBehaviour>().Charge = 200f;
    };
                             Instance.AddComponent<spider>();
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Welderinator9000",
                    DescriptionOverride = "Its a welding gun? Nobody knows how to describe it",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("wg.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fc.png");


                             Instance.AddComponent<hg>();

    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
                             Instance.AddComponent<hg>();
    };
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Lobster Claw (Back)",
                    DescriptionOverride = "Its a lobster claw, put it on and stab",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("clt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cl.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerArm";
                        prop.armorTier = 4;
                        prop.sprite = "cl.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }


        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop2 = ModAPI.FindPhysicalProperties("Human");
        prop2.Sharp = true;
        prop2.SharpAxes = new[]
            {

                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),

                };
        phys.Properties = prop2;
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Lobster Claw (Front)",
                    DescriptionOverride = "Its a lobster claw, put it on and stab",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("clt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("cl.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerArmFront";
                        prop.armorTier = 4;
                        prop.sprite = "cl.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }


        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop2 = ModAPI.FindPhysicalProperties("Human");
        prop2.Sharp = true;
        prop2.SharpAxes = new[]
            {

                                                                                    new SharpAxis(Vector2.down, 0f, 0.1f, true, false),

                };
        phys.Properties = prop2;
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "The Mid Gauntlet (Back)",
                    DescriptionOverride = "A gauntlet that charges energy overtime, and releases the energy onto whatever it hits",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("mgt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mg.png");
Instance.AddComponent<TManBehaviour>();

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerArm";
                        prop.armorTier = 4;
                        prop.sprite = "mg.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }


                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "The Mid Gauntlet (Front)",
                    DescriptionOverride = "A gauntlet that charges energy overtime, and releases the energy onto whatever it hits",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("mgt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("mg.png");
Instance.AddComponent<TManBehaviour>();

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerArmFront";
                        prop.armorTier = 4;
                        prop.sprite = "mg.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }


                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster"),
                    NameOverride = "Laser Belt",
                    DescriptionOverride = "Put it on and hump blast all your enemys away",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("belt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("b.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 4;
                        prop.sprite = "b.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Hypersonic Knife Launcher",
                    DescriptionOverride = "Goes onto the middle torso, launches high speed knifes that somehow defy gravity",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("hk.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bg.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("ballour");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("zg.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1.2f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;


                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "MiddleBody";
                        prop.armorTier = 4;
                        prop.sprite = "bg.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                    NameOverride = "Hypersonic Knife Gun",
                    DescriptionOverride = "Launches high speed knifes that somehow defy gravity, but faster",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("hgt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hsg.png");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileAsset = ModAPI.FindSpawnable("ballour");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().projectileLaunchStrength = 1.4f;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().RemoveLaunchedObjectsWithMe = false;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().launchSound = ModAPI.LoadSound("zg.mp3");
                        Instance.GetComponent<ProjectileLauncherBehaviour>().IsAutomatic = true;
                        Instance.GetComponent<ProjectileLauncherBehaviour>().AutomaticInterval = 0.12f;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "ballour",
                    NameToOrderByOverride = "!r",
                    DescriptionOverride = "A fashionable red mask!",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite("bl.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("bl.png");
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 3f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 3f;

                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.3f;

            Instance.AddComponent<ExplosiveBehaviour>();
            Instance.GetComponent<ExplosiveBehaviour>().Range = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().Delay = 15f;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 1;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
            Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ShotExplodeChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().DismemberChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().BigExplosion = false;
            Instance.GetComponent<ExplosiveBehaviour>().ParticleEffectAndSound = false;
                        var childObject2 = new GameObject();
                        childObject2.transform.SetParent(Instance.transform);
                        childObject2.transform.localPosition = new Vector3(0f, 0f);
                        childObject2.transform.localScale = new Vector3(1f, 1f);

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("Sprites-Default").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = new Color(0f, 0.5f, 1f, 2f);
                        line.startColor = new Color(0f, 0.5f, 1f, 2f);
                        line.sortingOrder = -3;

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Ice");
        prop.Sharp = true;
        prop.SharpAxes = new[]
            {

                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),

                };
        phys.Properties = prop;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Weird Looking Mask",
                    DescriptionOverride = "Some say it can shoot powerful lasers",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("sm.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("tm.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "tm.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                             Instance.AddComponent<sting>();
                        Instance.FixColliders();
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Epitaph",
                    DescriptionOverride = "Some weird head thing that can teleport on activation, given it has momentum",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("ept.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ep.png");

            var rb = Instance.GetComponent<Rigidbody2D>();
    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
	var e = ModAPI.CreateParticleEffect("Disintegration", Instance.transform.position);
        var m = e.GetComponent<ParticleSystem>().main;
                m.startColor = new Color(252f, 0f, 0f);
                var Colder = e.GetComponent<ParticleSystem>().main;
                Colder.startColor = new Color(252f, 0f, 0f);
            Instance.GetComponent<Rigidbody2D>().velocity = rb.velocity * 10;
    };

                        Instance.FixColliders();
                    }
                }
            );
             ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Shock Hat",
                    DescriptionOverride = "Put it on and then activate it, a fashionable death",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("sht.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sh.png");

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "sh.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

            var rb = Instance.GetComponent<Rigidbody2D>();
    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
        Instance.GetComponent<PhysicalBehaviour>().Charge = 300f;
    };
                             Instance.AddComponent<spider>();
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Thrusterbed"),
                    NameOverride = "Jetpack",
                    DescriptionOverride = "its uhhh, its a jetpack?",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("jpt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("jp.png");

            Instance.GetComponent<ThrusterbedBehaviour>().BurnRayWidth = 0.02f;
            Instance.GetComponent<ThrusterbedBehaviour>().TemperatureTarget = 0f;
            Instance.GetComponent<ThrusterbedBehaviour>().ThrustingForce = 20f;
            Instance.GetComponent<ThrusterbedBehaviour>().LayersToBurn = 0;
            Instance.GetComponent<ThrusterbedBehaviour>().BurnRayCount = 1;
            Instance.GetComponent<ThrusterbedBehaviour>().BurnRayWidth = 0.005f;
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "jp.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Freezeray"),
                    NameOverride = "Ice Dragons Mask",
                    DescriptionOverride = "Launches a powerful freezeray",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("idt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("id.png");

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.005f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.005f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "id.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Heatray"),
                    NameOverride = "Fire Dragons Mask",
                    DescriptionOverride = "Enemy of the Ice Dragon, launches a powerful heatray",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("fdt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fd.png");

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.005f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.005f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "fd.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Thrusterbed"),
                    NameOverride = "Missile",
                    DescriptionOverride = "On activation it flies in whatever direction its faces, and will detonate awhile after, leaving victims nearby completely destroyed",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("mst.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ms.png");

            Instance.GetComponent<ThrusterbedBehaviour>().BurnRayWidth = 0.02f;
            Instance.GetComponent<ThrusterbedBehaviour>().TemperatureTarget = 0f;
            Instance.GetComponent<ThrusterbedBehaviour>().ThrustingForce = 20f;
            Instance.GetComponent<ThrusterbedBehaviour>().LayersToBurn = 0;
            Instance.GetComponent<ThrusterbedBehaviour>().BurnRayCount = 1;
            Instance.GetComponent<ThrusterbedBehaviour>().BurnRayWidth = 0.005f;
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
            Instance.AddComponent<ExplosiveBehaviour>();
            Instance.GetComponent<ExplosiveBehaviour>().Range = 12f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 42f;
            Instance.GetComponent<ExplosiveBehaviour>().Delay = 5f;
            Instance.GetComponent<ExplosiveBehaviour>().AffectVictimTemperature = 702f;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 32;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 6f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 10;
            Instance.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
            Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 10f;
            Instance.GetComponent<ExplosiveBehaviour>().ShotExplodeChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().DismemberChance = 20f;
            Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().BigExplosion = true;
            Instance.GetComponent<ExplosiveBehaviour>().ParticleEffectAndSound = true;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sticky Grenade"),
                    NameOverride = "Blackhole Bomb",
                    DescriptionOverride = "Despite the name, it does not cause a blackhole. Instead it creates a powerful implosion",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("bhb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sg.png");

            Instance.GetComponent<StickyGrenadeBehaviour>().ArmedLightColour = new Color(0.5f, 0f, 1f);
            Instance.GetComponent<StickyGrenadeBehaviour>().HotLightColor = new Color(0.5f, 0.5f, 1f);
            Instance.GetComponent<StickyGrenadeBehaviour>().LightInterval = 10f;

            Instance.GetComponent<ExplosiveBehaviour>().Range = 16f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = -9250f;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 64;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = -90f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = -925f;
            Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ShotExplodeChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().DismemberChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0f;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Arc Reactor",
                    DescriptionOverride = "After putting it on, the wearer will slowly weaken",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("art.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ar.png");


        var childObject = new GameObject("Glow2");
        childObject.transform.SetParent(Instance.transform);


        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = ModAPI.LoadSprite("arg.png");
        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite.sortingLayerName = "Top";
        childSprite.color = new Color(0f, 0.5f, 1f, 0.3f);
        Vector3 savePos = Instance.transform.eulerAngles;
        Instance.transform.eulerAngles = new Vector3(0f, 0f, 0f);
        Instance.transform.eulerAngles = savePos;
        Instance.transform.GetChild(0).transform.eulerAngles = Instance.transform.eulerAngles;

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "ar.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
                             Instance.AddComponent<ar>();
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hover Thruster"),
                    NameOverride = "Moon Shoes (Front)",
                    DescriptionOverride = "Shoes that give the illusion of weak gravity",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("mb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fj.png");

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0005f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.0005f;

    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
        Instance.GetComponent<PhysicalBehaviour>().Charge = 30f;
    };

                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "FootFront";
                        prop.armorTier = 4;
                        prop.sprite = "fj.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hover Thruster"),
                    NameOverride = "Moon Shoes (Back)",
                    DescriptionOverride = "Shoes that give the illusion of weak gravity",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("mb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fj.png");


            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;

    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
        Instance.GetComponent<PhysicalBehaviour>().Charge = 30f;
    };
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Foot";
                        prop.armorTier = 4;
                        prop.sprite = "fj.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "decoy",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite("spm.png"),
                    AfterSpawn = (Instance) =>
                    {

                        var person = Instance.GetComponent<PersonBehaviour>();


            var skin = ModAPI.LoadTexture("decoy.png");
            var flesh = ModAPI.LoadTexture(" .png");
            var bone = ModAPI.LoadTexture(" .png");

                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");


        head.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        arm1.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        ar1.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        arm2.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        ar2.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        upper.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        middle.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        lower.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        fl1.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        fl2.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        fl3.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        l1.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        l2.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        l3.gameObject.GetComponent<LimbBehaviour>().BalanceMuscleMovement = 100f;
        head.gameObject.AddComponent<ExplosiveBehaviour>();
        arm1.gameObject.AddComponent<ExplosiveBehaviour>();
        ar1.gameObject.AddComponent<ExplosiveBehaviour>();
        arm2.gameObject.AddComponent<ExplosiveBehaviour>();
        ar2.gameObject.AddComponent<ExplosiveBehaviour>();
        upper.gameObject.AddComponent<ExplosiveBehaviour>();
        middle.gameObject.AddComponent<ExplosiveBehaviour>();
        lower.gameObject.AddComponent<ExplosiveBehaviour>();
        fl1.gameObject.AddComponent<ExplosiveBehaviour>();
        fl2.gameObject.AddComponent<ExplosiveBehaviour>();
        fl3.gameObject.AddComponent<ExplosiveBehaviour>();
        l1.gameObject.AddComponent<ExplosiveBehaviour>();
        l2.gameObject.AddComponent<ExplosiveBehaviour>();
        l3.gameObject.AddComponent<ExplosiveBehaviour>();
        head.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        arm1.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        ar1.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        arm2.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        ar2.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        upper.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        middle.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        lower.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        fl1.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        fl2.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        fl3.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        l1.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        l2.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        l3.gameObject.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
        head.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        arm1.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        ar1.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        arm2.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        ar2.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        upper.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        middle.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        lower.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        fl1.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        fl2.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        fl3.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        l1.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        l2.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        l3.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 10f;
        head.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        arm1.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        ar1.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        arm2.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        ar2.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        upper.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        middle.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        lower.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        fl1.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        fl2.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        fl3.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        l1.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        l2.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;
        l3.gameObject.GetComponent<ExplosiveBehaviour>().Range = 1f;




	Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);

                    }
                }
            );


            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Decoy Grenade",
                    DescriptionOverride = "On activation it spawns a decoy, a dumb human clone that self destructs after 10ish seconds",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("dct.png"),
                    AfterSpawn = (Instance) =>
                    {

   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("dg.png");


                             Instance.AddComponent<UseEventTrigger>().Action = () =>
                {
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("decoy").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("decoy"), Projectile);
                    Projectile.transform.rotation = Instance.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 0);
                    Projectile.transform.position = Instance.transform.position + (-Instance.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 23);
                };
        Instance.AddComponent<ExplosiveBehaviour>();
        Instance.GetComponent<ExplosiveBehaviour>().Delay = 0f;
        Instance.GetComponent<ExplosiveBehaviour>().Range = 0f;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Stand Disc",
                    DescriptionOverride = "If it makes contact with something at high speeds itll steal it, making the object invisible. Making contact with the stolen item at normal speeds will restore it, it is recommended to not let this touch the map as it turns it white",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("sd.png"),
                    AfterSpawn = (Instance) =>
                    {

   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("d.png");
                             Instance.AddComponent<r>();


                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Kusarigama",
                    DescriptionOverride = "A wearable wrist strap that has a knife on a teather linked to it",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("kt.png"),
                    AfterSpawn = (Instance) =>
                    {
   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("k.png");
                        var web = Instance.AddComponent<k>();
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Blaster Rifle"),
                    NameOverride = "Lad",
                    DescriptionOverride = "Laser Ass Destroyer, it go pew pew",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("lad.png"),
                    AfterSpawn = (Instance) =>
                    {

   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("p.png");
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 150f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 150f;

        Instance.GetComponent<BlasterBehaviour>().Recoil = 10f;
        Instance.GetComponent<BlasterBehaviour>().InaccuracyMultiplier = 0f;
        Instance.GetComponent<BlasterBehaviour>().Automatic = true;
        Instance.GetComponent<BlasterBehaviour>().Interval = 0.00000001f;
        Instance.GetComponent<BlasterBehaviour>().ScreenShakeMultiplier = 10f;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Umbrella",
                    DescriptionOverride = "Make sure a human is holding it. Its one of the umbrellas you can glide with, only after activation that is.",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("ut.png"),
                    AfterSpawn = (Instance) =>
                    {

   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("c.png");
            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.005f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.005f;

    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -68f;
   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("0.png");
    };
					var childObject = new GameObject();
					childObject.transform.SetParent(Instance.transform);
					childObject.transform.localPosition = new Vector3(0, 0f);
					var childSprite = childObject.AddComponent<SpriteRenderer>();
					childSprite.sprite = ModAPI.LoadSprite("o.png", 1f);
					childSprite.sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
					childSprite.color = new Color(0.0f, 0.0f, 0.0f, 0f);
					childSprite.sortingLayerName = "Top";
					Instance.GetOrAddComponent<light>().glowObj = childObject;
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"),
                    NameOverride = "Alternating Pistol",
                    DescriptionOverride = "Made out of a living being, the Alternating Pistol alternates between being a pistol and a knife",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("alt.png"),
                    AfterSpawn = (Instance) =>
                    {

   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("kn.png");


        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Human");
        prop.Sharp = true;
        prop.SharpAxes = new[]
            {

                            new SharpAxis(Vector2.right, 0f, 0.1f, true, false),

                };
        phys.Properties = prop;

					var childObject = new GameObject();
					childObject.transform.SetParent(Instance.transform);
					childObject.transform.localPosition = new Vector3(0, 0f);
					var childSprite = childObject.AddComponent<SpriteRenderer>();
					childSprite.sprite = ModAPI.LoadSprite("gu.png", 1f);
					childSprite.sharedMaterial = ModAPI.FindMaterial("Sprites-Default");
					childSprite.color = new Color(0.0f, 0.0f, 0.0f, 0f);
					childSprite.sortingLayerName = "Top";
					Instance.GetOrAddComponent<light>().glowObj = childObject;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Dynamite"),
                    NameOverride = "jksadfhjkdsfaqewfd",
                    DescriptionOverride = "Pulls things into it",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite("ait.png"),
                    AfterSpawn = (Instance) =>
                    {

            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ig.png");

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Metal");

        phys.Properties = prop;

            Instance.GetComponent<ExplosiveBehaviour>().Range = 2f;
            Instance.GetComponent<ExplosiveBehaviour>().ArmOnAwake = true;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = -225f;
            Instance.GetComponent<ExplosiveBehaviour>().Delay = 2f;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 32;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 6f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 10;
            Instance.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
            Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 100f;
            Instance.GetComponent<ExplosiveBehaviour>().ShotExplodeChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().DismemberChance = 20f;
            Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().BigExplosion = false;
            Instance.GetComponent<ExplosiveBehaviour>().ParticleEffectAndSound = true;

                        var childObject = new GameObject();
                        childObject.transform.SetParent(Instance.transform);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);

                       var line = Instance.AddComponent<TrailRenderer>();
                        line.startWidth = 0.1f;
                        line.material = ModAPI.FindMaterial("Sprites-Default").ShallowClone();
                        line.time = 0.1f;
                        line.endColor = new Color(1f, 0f, 1f, 0.05f);
                        line.startColor = new Color(1f, 0f, 0f, 0.1f);
                        line.sortingOrder = -3;

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Dynamite"),
                    NameOverride = "Freeze Bomb",
                    DescriptionOverride = "Freezes anything in its radius",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("fbt.png"),
                    AfterSpawn = (Instance) =>
                    {

            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fb.png");

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Metal");

        phys.Properties = prop;

        var childObject = new GameObject("Glow2");
        childObject.transform.SetParent(Instance.transform);


        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = ModAPI.LoadSprite("fbg.png");
        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite.sortingLayerName = "Back";
        childSprite.color = new Color(0f, 0.5f, 1f, 0.3f);
        Vector3 savePos = Instance.transform.eulerAngles;
        Instance.transform.eulerAngles = new Vector3(0f, 0f, 0f);
        Instance.transform.eulerAngles = savePos;
        Instance.transform.GetChild(0).transform.eulerAngles = Instance.transform.eulerAngles;

            Instance.GetComponent<ExplosiveBehaviour>().Range = 6f;
            Instance.GetComponent<ExplosiveBehaviour>().AffectVictimTemperature = -999999999f;
            Instance.GetComponent<ExplosiveBehaviour>().BurnPower = -9999f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().Delay = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 32;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 0;
            Instance.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
            Instance.GetComponent<ExplosiveBehaviour>().ShotExplodeChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().BigExplosion = false;
            Instance.GetComponent<ExplosiveBehaviour>().ParticleEffectAndSound = true;

    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
	var e = ModAPI.CreateParticleEffect("HugeZap", Instance.transform.position);
        var m = e.GetComponent<ParticleSystem>().main;
                m.startColor = new Color(0f, 0f, 252f);
                var Colder = e.GetComponent<ParticleSystem>().main;
                Colder.startColor = new Color(0f, 0f, 252f);
    };


                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Dynamite"),
                    NameOverride = "Heat Bomb",
                    DescriptionOverride = "Heats anything in its radius",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("hbt.png"),
                    AfterSpawn = (Instance) =>
                    {

            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("fb.png");

        var phys = Instance.GetComponent<PhysicalBehaviour>();
        var prop = ModAPI.FindPhysicalProperties("Metal");

        phys.Properties = prop;

        var childObject = new GameObject("Glow2");
        childObject.transform.SetParent(Instance.transform);


        childObject.transform.localPosition = new Vector3(0f, 0f);
        childObject.transform.localScale = new Vector3(1f, 1f);
        var childSprite = childObject.AddComponent<SpriteRenderer>();
        childSprite.sprite = ModAPI.LoadSprite("fbg.png");
        childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
        childSprite.sortingLayerName = "Back";
        childSprite.color = new Color(1f, 0f, 0f, 0.3f);
        Vector3 savePos = Instance.transform.eulerAngles;
        Instance.transform.eulerAngles = new Vector3(0f, 0f, 0f);
        Instance.transform.eulerAngles = savePos;
        Instance.transform.GetChild(0).transform.eulerAngles = Instance.transform.eulerAngles;

            Instance.GetComponent<ExplosiveBehaviour>().Range = 6f;
            Instance.GetComponent<ExplosiveBehaviour>().AffectVictimTemperature = 999f;
            Instance.GetComponent<ExplosiveBehaviour>().BurnPower = -9999f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().Delay = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentationRayCount = 32;
            Instance.GetComponent<ExplosiveBehaviour>().FragmentForce = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 0;
            Instance.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
            Instance.GetComponent<ExplosiveBehaviour>().ShotExplodeChance = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 0f;
            Instance.GetComponent<ExplosiveBehaviour>().BigExplosion = false;
            Instance.GetComponent<ExplosiveBehaviour>().ParticleEffectAndSound = true;

    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
	var e = ModAPI.CreateParticleEffect("HugeZap", Instance.transform.position);
        var m = e.GetComponent<ParticleSystem>().main;
                m.startColor = new Color(252f, 0f, 0f);
                var Colder = e.GetComponent<ParticleSystem>().main;
                Colder.startColor = new Color(252f, 0f, 0f);
    };


                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Hover Thruster"),
                    NameOverride = "Bomber Drone",
                    DescriptionOverride = "On activation itll drop a small bomb out of its bottom",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("bd.png"),
                    AfterSpawn = (Instance) =>
                    {

   Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("do.png");
                        Instance.GetComponent<HoverThrusterBehaviour>().Activated = true;
                        Instance.AddComponent<ProjectileLauncherBehaviour>();
                        Instance.GetComponent<DamagableMachineryBehaviour>().Health = float.PositiveInfinity;
    Instance.AddComponent<UseEventTrigger>().Action = () =>
    {
                        Instance.GetComponent<HoverThrusterBehaviour>().Activated = true;
                    GameObject Projectile = GameObject.Instantiate(ModAPI.FindSpawnable("jksadfhjkdsfaqewfd").Prefab);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("jksadfhjkdsfaqewfd"), Projectile);
                    Projectile.transform.rotation = Instance.transform.rotation;
                    Projectile.transform.eulerAngles += new Vector3(0, 0, 180);
                    Projectile.transform.position = Instance.transform.position + (-Instance.transform.up * 0.5f);
                    Projectile.GetComponent<Rigidbody2D>().AddRelativeForce(Projectile.transform.up * 23);
    };
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Front Arm Prosthetic (Human)",
                    DescriptionOverride = "Goes onto the upper torso of a human, may require you to move the arms to make it look good. Arms do not have collision to avoid making contact with the body",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("hap.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    lower.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    head.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                            ar1.gameObject.layer = 10;
                            arm1.gameObject.layer = 10;


                        int PartCount = 1;

                        if (!upper.gameObject.GetComponent<ArmorBehaviour>())
                             upper.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = upper.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "pu.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Front Arm Prosthetic (Robotic)",
                    DescriptionOverride = "An enhanced prosthetic. Goes onto the upper torso of a human, may require you to move the arms to make it look good. Arms do not have collision to avoid making contact with the body",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("rat.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
            var skin = ModAPI.LoadTexture("sp.png");
            var flesh = ModAPI.LoadTexture("sp.png");
            var bone = ModAPI.LoadTexture("sp.png");
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 4f;
                            body.Health += 1000000000f;
                            body.InitialHealth += 1000000000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 999999999f;
                            body.RegenerationSpeed += 999999999f;
                            body.CirculationBehaviour.BloodFlow *= 4f;
                  body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                        }

			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    lower.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    head.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                            ar1.gameObject.layer = 10;
                            arm1.gameObject.layer = 10;


                        int PartCount = 1;

                        if (!upper.gameObject.GetComponent<ArmorBehaviour>())
                             upper.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = upper.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "pu.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
	Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Back Arm Prosthetic (Robotic)",
                    DescriptionOverride = "An enhanced prosthetic. Goes onto the upper torso of a human, may require you to move the arms to make it look good. Arms do not have collision to avoid making contact with the body",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("rat.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
            var skin = ModAPI.LoadTexture("sp.png");
            var flesh = ModAPI.LoadTexture("sp.png");
            var bone = ModAPI.LoadTexture("sp.png");
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 4f;
                            body.Health += 1000000000f;
                            body.InitialHealth += 1000000000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 999999999f;
                            body.RegenerationSpeed += 999999999f;
                            body.CirculationBehaviour.BloodFlow *= 4f;
                  body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                        }

			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    lower.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    head.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                            ar2.gameObject.layer = 10;
                            arm2.gameObject.layer = 10;


                        int PartCount = 1;

                        if (!upper.gameObject.GetComponent<ArmorBehaviour>())
                             upper.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = upper.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "pu.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
	Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Robotic Body",
                    DescriptionOverride = "A body used to host lifes, shoot off the head of whatever you want and put it ontop of the upper part of the suit",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("rbt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
            var skin = ModAPI.LoadTexture("sp.png");
            var flesh = ModAPI.LoadTexture("sp.png");
            var bone = ModAPI.LoadTexture("sp.png");
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 8f;
                            body.Health += 1000000000f;
                            body.InitialHealth += 1000000000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 999999999f;
                            body.RegenerationSpeed += 999999999f;
                            body.CirculationBehaviour.BloodFlow *= 4f;
                  body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                        }






                            head.gameObject.layer = 10;
                            ar1.gameObject.AddComponent<zregen>();
                            head.gameObject.AddComponent<zregen>();
                            ar2.gameObject.AddComponent<zregen>();
                            arm1.gameObject.AddComponent<zregen>();
                            arm2.gameObject.AddComponent<zregen>();
                            l1.gameObject.AddComponent<zregen>();
                            l2.gameObject.AddComponent<zregen>();
                            l3.gameObject.AddComponent<zregen>();
                            fl1.gameObject.AddComponent<zregen>();
                            fl2.gameObject.AddComponent<zregen>();
                            fl3.gameObject.AddComponent<zregen>();
                            upper.gameObject.AddComponent<zregen>();
                            middle.gameObject.AddComponent<zregen>();
                            lower.gameObject.AddComponent<zregen>();
                            ar1.gameObject.AddComponent<mech>();
                            head.gameObject.AddComponent<mech>();
                            ar2.gameObject.AddComponent<mech>();
                            arm1.gameObject.AddComponent<mech>();
                            arm2.gameObject.AddComponent<mech>();
                            l1.gameObject.AddComponent<mech>();
                            l2.gameObject.AddComponent<mech>();
                            l3.gameObject.AddComponent<mech>();
                            fl1.gameObject.AddComponent<mech>();
                            fl2.gameObject.AddComponent<mech>();
                            fl3.gameObject.AddComponent<mech>();
                            upper.gameObject.AddComponent<mech>();
                            middle.gameObject.AddComponent<mech>();
                            lower.gameObject.AddComponent<mech>();


                        int PartCount = 1;

                             upper.gameObject.AddComponent<mech>();

                        if (!upper.gameObject.GetComponent<ArmorBehaviour>())
                             upper.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = upper.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "bb.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
	Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Mech",
                    DescriptionOverride = "A larger version of the robotic body",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("mect.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
            var skin = ModAPI.LoadTexture("me.png");
            var flesh = ModAPI.LoadTexture("me.png");
            var bone = ModAPI.LoadTexture("me.png");
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 8f;
                            body.Health += 1000000000f;
                            body.InitialHealth += 1000000000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 999999999f;
                            body.RegenerationSpeed += 999999999f;
                            body.CirculationBehaviour.BloodFlow *= 4f;
                  body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                 body.transform.root.localScale *= 1.05f;  
                        }






                            head.gameObject.layer = 10;
                            ar1.gameObject.AddComponent<zregen>();
                            head.gameObject.AddComponent<zregen>();
                            ar2.gameObject.AddComponent<zregen>();
                            arm1.gameObject.AddComponent<zregen>();
                            arm2.gameObject.AddComponent<zregen>();
                            l1.gameObject.AddComponent<zregen>();
                            l2.gameObject.AddComponent<zregen>();
                            l3.gameObject.AddComponent<zregen>();
                            fl1.gameObject.AddComponent<zregen>();
                            fl2.gameObject.AddComponent<zregen>();
                            fl3.gameObject.AddComponent<zregen>();
                            upper.gameObject.AddComponent<zregen>();
                            middle.gameObject.AddComponent<zregen>();
                            lower.gameObject.AddComponent<zregen>();
                            ar1.gameObject.AddComponent<mech>();
                            head.gameObject.AddComponent<mech>();
                            ar2.gameObject.AddComponent<mech>();
                            arm1.gameObject.AddComponent<mech>();
                            arm2.gameObject.AddComponent<mech>();
                            l1.gameObject.AddComponent<mech>();
                            l2.gameObject.AddComponent<mech>();
                            l3.gameObject.AddComponent<mech>();
                            fl1.gameObject.AddComponent<mech>();
                            fl2.gameObject.AddComponent<mech>();
                            fl3.gameObject.AddComponent<mech>();
                            upper.gameObject.AddComponent<mech>();
                            middle.gameObject.AddComponent<mech>();
                            lower.gameObject.AddComponent<mech>();


                        int PartCount = 1;

                             upper.gameObject.AddComponent<mech>();

                        if (!upper.gameObject.GetComponent<ArmorBehaviour>())
                             upper.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = upper.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "bb.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
	Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Doc Ock Tentacles",
                    DescriptionOverride = "Goes onto the middle part of a human, its just the tentacles from spiderman, spawn in more pairs to well, have more tentacles",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("doc.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
            var skin = ModAPI.LoadTexture("dc.png");
            var flesh = ModAPI.LoadTexture("dc.png");
            var bone = ModAPI.LoadTexture("dc.png");
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

                        foreach (var body in person.Limbs)
                        {
                            body.BaseStrength *= 4f;
                            body.Health += 1000000000f;
                            body.InitialHealth += 1000000000f;
                            body.ShotDamageMultiplier *= 0f;
                            body.Vitality *= 4.5f;
                            body.ImpactPainMultiplier *= 0f;
                            body.Numbness *= 2f;
                            body.IsLethalToBreak = false;
                            body.BreakingThreshold += 999999999f;
                            body.RegenerationSpeed += 999999999f;
                            body.CirculationBehaviour.BloodFlow *= 4f;
                 body.transform.root.localScale *= 1.08f;  
                  body.PhysicalBehaviour.Properties = ModAPI.FindPhysicalProperties("Metal");
                        }

			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    lower.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    head.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                            ar2.gameObject.layer = 10;
                            arm2.gameObject.layer = 10;
                            ar1.gameObject.layer = 10;
                            arm1.gameObject.layer = 10;
                            ar2.gameObject.AddComponent<zregen>();
                            arm2.gameObject.AddComponent<zregen>();
                            ar1.gameObject.AddComponent<zregen>();
                            arm1.gameObject.AddComponent<zregen>();
                            upper.gameObject.AddComponent<zregen>();


                        int PartCount = 1;

                        if (!upper.gameObject.GetComponent<ArmorBehaviour>())
                             upper.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = upper.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "MiddleBody";
                        prop.armorTier = 4;
                        prop.sprite = "pu.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
	Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin,flesh,bone);
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Back Arm Prosthetic (Human)",
                    DescriptionOverride = "Goes onto the upper torso of a human, may require you to move the arms to make it look good. Arms do not have collision to avoid making contact with the body",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("hap.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    lower.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    head.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                            ar2.gameObject.layer = 10;
                            arm2.gameObject.layer = 10;


                        int PartCount = 1;

                        if (!upper.gameObject.GetComponent<ArmorBehaviour>())
                             upper.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = upper.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "pu.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Front Leg Prosthetic (Human)",
                    DescriptionOverride = "Goes onto the lower torso of a human, may require you to move the legs to make it look good. Legs do not have collision to avoid making contact with the body",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("hal.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

			    upper.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    head.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                            fl1.gameObject.layer = 10;
                            fl2.gameObject.layer = 10;
                            fl3.gameObject.layer = 10;
                            fl1.gameObject.AddComponent<zregen>();
                            fl2.gameObject.AddComponent<zregen>();
                            fl3.gameObject.AddComponent<zregen>();

                        int PartCount = 1;

                        if (!lower.gameObject.GetComponent<ArmorBehaviour>())
                             lower.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = lower.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 4;
                        prop.sprite = "pu.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Back Leg Prosthetic (Human)",
                    DescriptionOverride = "Goes onto the lower torso of a human, may require you to move the legs to make it look good. Legs do not have collision to avoid making contact with the body",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("hal.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var arm1 = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = Instance.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = Instance.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = Instance.transform.Find("BackArm").Find("LowerArm");
                        var head = Instance.transform.Find("Head");
                        var upper = Instance.transform.Find("Body").Find("UpperBody");
                        var middle = Instance.transform.Find("Body").Find("MiddleBody");
                        var lower = Instance.transform.Find("Body").Find("LowerBody");
                        var fl1 = Instance.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = Instance.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = Instance.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = Instance.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = Instance.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = Instance.transform.Find("BackLeg").Find("Foot");

			    upper.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    head.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();


                            l1.gameObject.layer = 10;
                           l2.gameObject.layer = 10;
                            l3.gameObject.layer = 10;
                            l1.gameObject.AddComponent<zregen>();
                            l2.gameObject.AddComponent<zregen>();
                            l3.gameObject.AddComponent<zregen>();

                        int PartCount = 1;

                        if (!lower.gameObject.GetComponent<ArmorBehaviour>())
                             lower.gameObject.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = lower.gameObject.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 4;
                        prop.sprite = "pu.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Torch"),
                    NameOverride = "fireball",
                    DescriptionOverride = "",
                    CategoryOverride = ModAPI.FindCategory(" "),
                    ThumbnailOverride = ModAPI.LoadSprite("db.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("db.png");
                        Instance.GetComponent<TorchBehaviour>().TransferSpeed = 1000f;
                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Light Mask",
                    DescriptionOverride = "Goes onto the upper torso, on activation it spawns a delayed mask forged from a hologram",
                    CategoryOverride = ModAPI.FindCategory("Zuccians Laboratory"),
                    ThumbnailOverride = ModAPI.LoadSprite("lmt.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("w.png");

            Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.5f;
            Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.5f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                             Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();
                        Vector3 offset = new Vector3(0, 0);
                        Vector3 scaleOffset = new Vector3(0f, 0f);

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "w.png";
                        prop.offset = offset;
                        prop.scaleOffset = scaleOffset;

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

					var childObject = new GameObject();
					childObject.transform.SetParent(Instance.transform);
					childObject.transform.localPosition = new Vector3(0, 0f);
					var childSprite = childObject.AddComponent<SpriteRenderer>();
					childSprite.sprite = ModAPI.LoadSprite("rm.png", 1f);
					childSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
					childSprite.color = new Color(0.0f, 0.0f, 0.0f, 0.05f);
					childSprite.sortingLayerName = "Top";
					Instance.GetOrAddComponent<light>().glowObj = childObject;
                        Instance.FixColliders();
				}
			});
		}
    }
	
    public class light : MonoBehaviour
    {
        public bool enabled = false;
		public GameObject glowObj;
		
        private void Use()
        {
            enabled = !enabled;
			SetEnabled(enabled);
        }
		
		private void SetEnabled(bool status)
		{
			enabled = status;
			glowObj.GetComponent<SpriteRenderer>().color = status ? Color.white : Color.clear;
		}
		
       
        private void Start()
        {
			SetEnabled(enabled);
			glowObj.transform.eulerAngles = transform.eulerAngles;
			glowObj.transform.localScale = transform.localScale;
        }
    }
}